/*
	Write by LinJuangHua(xempo) 12-2013
	xempo 保留此文件的原有版权
	Free under LGPL
*/

#include <qclipboard.h>
#include "ordir.h"
#include "editor.h"
#include "proedit.h"
#include "filesan.h"
#include "calc.def"

#include "highlight.cpp"
// #include "peconf.cpp"

static const char _unitSepa[]=":,;\\/\t \n";

Editor::Editor(QWidget *w) : QTextEdit(w),proedit((ProEdit *)w),
	todoMsg(false), update(false), Sel_feel(false), Paste_feel(0),
	saveP(-1), smP(0), highlighter(NULL), unitSepa(_unitSepa)
{
setTextFormat(PlainText);
setAcceptDrops(true);
}

Editor::~Editor()
{
}

void Editor::curFeel(const char *txt, int idx)
{
  int i, yh=0;
  Undo_feel=false;	Paste_feel=0;
  if(txt)for( i=0; txt[i]; i++){
	if(txt[i]==highlighter->_block1 && txt[i+1]==highlighter->_block2){
		CS_feel=true; YH_feel=false; return;
		}
	else if(i<=idx&&isYH(txt,i))yh++;
	}
  YH_feel=(yh%2);
  CS_feel=false;
}

void Editor::styleFeel()
{
if(highlighter){
	int p, i;
	highlighter->setInputLine(CS_Modifying);
	if(hasSelectedText()){ Sel_feel=true; del(); }
	getCursorPosition(&p, &i);
	curFeel(text(p), i);
	Paste_feel=1;
//	YH_feel=false;
	Sel_feel=false;
}
}

void Editor::paste()
{
if(highlighter)styleFeel();
QTextEdit::paste();
}

void Editor::cut()
{
if(highlighter){
    Paste_feel=0;
    CS_feel=false;  YH_feel=false;  Undo_feel=false;
    switch(highlighter->feelFormat(selectedText(), -1)){
    case SC_BZ_c : CS_feel=true;
		// break;
    }
highlighter->setInputLine(CS_Modifying);
}
QTextEdit::cut();
}

void Editor::undo()
{
if(highlighter){
	highlighter->setInputLine(CS_Modifying);
	todoMsg=true;	Paste_feel=0;
	Undo_feel=true;
	CS_feel=true;
	}
QTextEdit::undo();
}

void Editor::redo()
{
if(highlighter){
	highlighter->setInputLine(CS_Modifying);
	todoMsg=true;	Paste_feel=0;
	Undo_feel=true;
	CS_feel=true;
	}
QTextEdit::redo();
}

static const char syb_for[4]={ '{' , '[' , '(' , '<' },
	syb_back[4]={ '}' , ']' , ')' , '>' };

#define	spch	'\''
#define	spst	'\"'
enum zhuxi { SingleZhu=1, // no use
	MultZhu=2, InString=3 };

bool Editor::sybForward(const char *ptxt, int p, int i)
{
 while(ptxt[i]){
    if( isYH(ptxt,i) )
	switch(zhu){
	case 0 : zhu=InString;
		break;
	case InString : zhu=0;
	}
    else if(ptxt[i]=='/'&&zhu!=InString){
	if( i>0&&ptxt[i-1]=='*' )zhu=0;
	else if(ptxt[i+1]=='*')zhu=MultZhu;
		else if(ptxt[i+1]=='/'&&zhu!=MultZhu)return false;
	}

  if(zhu==0 && (ptxt[i+1]!=spch||(i==0 || i>0 && ptxt[i-1]!=spch ) ))
	if(ptxt[i]==syb_back[sybCount]){
		if(cn_syb-- == 0){
			setCursorPosition(p, i); return true;
			}
		}
	else if(ptxt[i]==syb_for[sybCount])cn_syb++;
  i++;
  }
return false;
}

bool Editor::sybBackward(const char *ptxt, int p, int i)
{
int c;
for(c=0; (c<i||(i<-1&&ptxt[c])) && !(ptxt[c]=='/' && ptxt[c+1]=='/'&&zhu==0); c++)
     if( isYH(ptxt,c) )
	switch(zhu){
	case 0 : zhu=InString;
		break;
	case InString : zhu=0;
	}
	else if(ptxt[c]=='/' ){
		if(ptxt[c+1]=='*'&&zhu==0)zhu=MultZhu;
		else if(c>0&&ptxt[c-1]=='*'&&zhu==MultZhu)zhu=0;
		}
if(ptxt[c]==0||ptxt[c]=='/')i=c;

while(i>-1){
    if(isYH(ptxt,i ) )
	switch(zhu){
	case 0 : zhu=InString;
		break;
	case InString : zhu=0;
	}
    else if(ptxt[i]=='/'&&zhu!=InString){
	if(ptxt[i+1]=='*')zhu=0;
//	else if(ptxt[i+1]=='/'&&zhu==MultZhu){zhu=0;}
	         else if(i>0 && ptxt[i-1]=='*')zhu=MultZhu;
	}
  if(zhu==0){
    if(ptxt[i+1]!=spch||( i==0 || i>0 && ptxt[i-1]!=spch) )
	if(ptxt[i]==syb_for[sybCount]){
		if( cn_syb-- == 0 ){
			setCursorPosition(p, i); return true;
			}
		}
	else if(ptxt[i]==syb_back[sybCount])cn_syb++;
	}
	i--; // " } ll "
  }
return false;
}

bool Editor::sybJmp(const char *ptxt, int p, int i)
{
int Lines=lines();
for(sybCount=0; sybCount<4; sybCount++){
	if( ptxt[i]==syb_for[sybCount] && !(i>0&&ptxt[i-1]==spch&&ptxt[i+1]==spch) ||
	i>0&&ptxt[i-1]==syb_for[sybCount] && !(i>1&&ptxt[i-2]==spch&&ptxt[i]==spch)
	){
	if(ptxt[i]==syb_for[sybCount])i++;
	if(sybForward(ptxt, p, i))return true;
	while(++p<Lines )
		if(sybForward(text(p), p, 0))return true;
	break;
	}
	else if( ptxt[i]==syb_back[sybCount]&& !(i>0&&ptxt[i-1]==spch&&ptxt[i+1]==spch)
	|| i>0&&ptxt[i-1]==syb_back[sybCount] && !( i>1&&ptxt[i-2]==spch&&ptxt[i]==spch) 
	){
	if(i>0){
		if(ptxt[--i]==syb_back[sybCount])i--; 
		if(i>-1&&sybBackward(ptxt, p, i))return true;
	}
	while(--p>-1)
		if(sybBackward(text(p), p, -2))return true; 
	break;
	}
}
return false;
}

const char  div_syb[]=".+-*/%\t:\"\'&\\|=! <>[]{}(),;\n\r";
static const char selFileTag[]="\t \"\'&|<>{}(),;\n\r";
void Editor::keysFunc(int k, int st)
{
  int p, i, b, ln,  n; // n=结尾;
  const char *pt;
  char *ptxt;
  getCursorPosition(&p, &i);
  if(highlighter){
	highlighter->setInputLine(CS_Modifying);
	curFeel(text(p), i);
	if(k!=Key_Return&&k!=Key_Delete&&k!=Key_BackSpace)YH_feel=false;
  }
  if( st&AltButton )switch( k ){
   case ']' :
   case '[' : _jmp_c_ : cn_syb=0; zhu=0;
	sybJmp(text(p), p, i);
	if(st==ControlButton){
		getCursorPosition(&n, &b);
		setSelection(p, i, n,b);
		}
	break;
   case Key_F6 : // fast linkopen		
	goto _lnk_;
   case 'S' :	if(hasSelectedText())goto _asSrc_;
		pt=selFileTag;
		goto _skp0_;
   case 'R' : if(unitSepa!=_unitSepa){
		free((void *)unitSepa);
		unitSepa=_unitSepa;
		}
	break;
   case 'T' : insert(QDateTime::currentDateTime().toString(dtfmtlst.lstIndex(__params[54])) );
	break;
   case 'E' :
   case 'B' :
   case 'O' :
   case 'U' :
	if(hasSelectedText()){
		char buf[80], *tmp;
		int j,  msg;
		switch(k){
		case 'E' : if(unitSepa!=_unitSepa)free((void *)unitSepa);
			tmp=strdup(selectedText());
			unitSepa=tmp;
			for(i=0; unitSepa[i]; i++)
				if(unitSepa[i]=='\\')
				switch(unitSepa[i+1]){
				case '\\' : goto _jmp_del_;
				case 'n' : tmp[i]='\n';
					goto _jmp_del_;
				case 't' : tmp[i]=9;
				_jmp_del_: strcut(tmp+i+1, 1); 
					break;
				default : b=i+1;
					if(unitSepa[b]=='0'){
						msg = (unitSepa[b+1]|32)=='x' ? 2 : 1;
						}
					else msg=0;
					for(j=0; unitSepa[b]>'0'-1 &&unitSepa[b]<'9'+1 ||
						(unitSepa[b]|32)=='x' && unitSepa[b-1]=='0' ; b++, j++)buf[j]=unitSepa[b];
					buf[j]=0;
					sscanf(buf, msg ? (msg>1 ? "%x" : "%o") : "%d", &b);
					tmp[i]=b;
					strcut(tmp+i+1, j);
				}
			return;
		case 'B' :	//b=strlen((const char *)__from_unicode(selectedText()));
			proedit->curCodec()->fromUnicode(selectedText(), b=0x20000);
			i=0;
			break;
		case 'O' :	b=selectedText().length();
			i=1;	break;
		case 'U' : b=900000;	i=2;
			setargv((char *)(const char *)selectedText(), unitSepa, &b);
		}
		sprintf(buf, p_countChs[i], b);
		infoWidget(buf, NULL, countInfo, proedit);
		}
	break;
   case 'N' : // _sel_func_:
   case 'D' :  if(hasSelectedText())goto _calc_;
	pt="\t:\"\'&\\|=! <>,;";
	goto _skp0_;
   case 'J'  : _norm_sel_: pt=div_syb;
	goto _skp0_;
   case 'K'  :  pt="{}()[]<>;"; //largeSelDiv;
	goto _skp0_;
   case 'L'  :
_skp0_:	{
	  QString mid(text(p));
	  if(k==Key_F6)ptxt=strdup(proedit->curCodec()->fromUnicode(mid));  // disk real chars
	  else ptxt=strdup(mid);  // views pos
	  ln=strlen(ptxt);
	  switch(k){
	  case 'T' : n=i;
		goto _jmp_;
	  case 'L' : n=ln;
	_jmp_:	b=0;
		goto _skp_;
	  }
	  mid.truncate(i);/* 注意中文字与英文字母的大小差*/
	  b=strlen(mid);
	}
	for(n=b; b>=0 && strchr(pt, ptxt[b])==NULL; b--) ;
	if(b<n)b++;
	while(n<ln && strchr(pt, ptxt[n])==NULL)n++;
	if(n>=ln)n--;
	if(k==Key_F6){ // linkopen
	  ptxt[n]=0;
	_fastOpen_: proedit->getFilesor()->doProEdit(ptxt+b, st==AltButton);
	  n=0;
	}
	_skp_:free(ptxt);
	if(n>b){
		// k!='N' && k!='D' && k!='X'&&k!='Z'
		setSelection(p, b, p, n);
		proedit->eacActSelection();
		switch(k){
		case Key_S : _asSrc_: selAsSrc.resetMem(strdup(selectedText().local8Bit()), ";\n");
			proedit->getFilesor()->setCopyStats(selAsSrc.bufferString('\n'));
//			selAsSrc.memDiv("\n");
			break;
		case Key_T : del();	break;
		case Key_F9 :
		case Key_F8 : _get_help_: proedit->getHelp(selectedText(), k==Key_F9, st&ControlButton);
//			qWarning("getHelp(%s)", (const char *)selectedText());
			break;
		case 'N' :
		case 'D' : _calc_: {
			char buf[ 80 ];
			double d=calc(selectedText());
			if(n_CalcErr)
				infoWidget(calcErr(), NULL, calcerrInfo, proedit);
			else {
				sprintf(buf, k!='N'? "%lf" : "%g", d );
				insert(buf);
			}
			}
		}
	}
     }
     else if(st==ControlButton)switch(k){
	case Key_F8 :
	case Key_F9 : if(hasSelectedText())goto _get_help_;
			else goto _norm_sel_;
	case ']' :
	case '[' :	 goto _jmp_c_;
	case 'T' : goto _skp0_;
	case 'U' :	removeParagraph(p);
		break;
	case 'Q' : if(proedit->close())
			QApplication::postEvent(qApp, new QCloseEvent ); // 2 above Fophonix must like thus
	}
	else switch(k){
		case Key_F10 : loadSearchModify(proedit->getFilesor());
			break;
		case Key_F6  :_lnk_: if(hasSelectedText()){
				ptxt=strdup(proedit->curCodec()->fromUnicode(selectedText()));
				b=0;
				goto _fastOpen_;
				}
				pt=selFileTag;
				goto _skp0_;
		case Key_F5 :
			if(proEditList.count()>1)proEditList.at(1)->showTop();
			else QApplication::beep();
			break;
		case Key_F9 :
		case Key_F8 : if(hasSelectedText())goto _get_help_;
				else goto _norm_sel_;
		case Key_F12 : proedit->getFilesor()->showTop();
				break;
		case Key_F11 :	proedit->getFilesor()->openSelect(proedit->getPath(),
				strrchr(proedit->getFileName(), '/')+1 );
				break;				
		case Key_F7 : QApplication::clipboard()->setText(topLevelWidget()->caption(), QClipboard::Clipboard);
				break;
		case Key_F1 : ORLLink(proedit->getFilesor(), 4, 2/* new wdg */);
	}
}

bool Editor::event( QEvent *e)
{
switch(e->type()){
case QEvent::KeyPress :
	keysFunc(((QKeyEvent *)e)->key(),((QKeyEvent *)e)->state());
}
return QTextEdit::event(e);
}
