/*
	Write by xempo 2013
	Free under LGPL
*/

#ifndef	  High_Light
#define	High_Light

#include <qsyntaxhighlighter.h>
#include "txtstyle.h"

class Editor;

enum SC { SC_Norm=0, SC_BZ_cpp=1,  SC_BZ_c=2,  SC_YH=3 }; /* highlight */

#define  CS_Modifying  -9
#define  CS_Init  -10

class HighLighter : protected QSyntaxHighlighter
{
friend class Editor;
public :
 HighLighter( Editor *textEdit, const StyleVal *c, const unsigned int *line_style, int Cnt,
	const char ***ctype, const TxtStyle *cstyle,  const char *sybel);
 void init(){
	_init();
	rehighlight();
	}

 void setInputLine(int val){ inputLine=val; }

 void setFnt(const QFont &fnt1){ fnt=fnt1; }

 void setCStyle(const StyleVal *c, const unsigned int *line_style){
	colors=c;
	YHcolor=line_style[0];
	BZcolor=line_style[1];
	cppBZcolor=line_style[2];
 }

 void _init();
 int feelFormat(const char *pt, int p);

protected :
 virtual int highlightParagraph( const QString &text, int endStateOfLastPara );

private:
 const unsigned int  orgColor;
 QFont fnt;
 void setStyle(int s, int len, unsigned int c, bool bold, bool italic, bool UL);

 int paraBack, styleCount, orgline,
	inputLine; // >0特殊，-9 常态input
 char  _line1, _line2,
	_block1, _block2, _block3, _block4;

 Editor *edt;
 const TxtStyle *c_style[c_style_count+1];
 unsigned int YHcolor, BZcolor, cppBZcolor;
 const StyleVal *colors;
 const char **c_type[c_style_count+1];
//--------------backup status---------

};

#endif
