/*
	Write by LinJiangHua(xempo) 2012-2013
	Copyright LinJiangHua 2012-2013
*/

/*  CC in ../libnorm/cfun.c  */

#include "txtstyle.h"

static const char *ctype0[11]={ "define","undef","if","else","endif","elif", "ifdef", "ifndef", "pragma", "error", "line" },
	*ctype1="include",
	*ctype2[13]={ "char","long","void","short","unsigned","signed","float","double","bool","struct","union","class","int" },
	*ctype3="return",  *ctype4="else", *ctype5="default", *ctype6="case",
	*ctype7[3]={ "break", "continue" ,"goto" }, *ctype8[5]={	"while","if","for","switch","catch" },
	*ctype9[3]={"extern","static","friend"}, *ctype10[2]={ "true","false" },  *ctype11[2]={"const","__const" },
	*ctype12="new", *ctype13="delete", *ctype14[2]={"try","do"},*ctype15="sizeof",*ctype16="this",
	*ctype17[4]={"public","protected","private","slots"}, *ctype18[2]={"inline","enum"},
	*ctype19="typedef",	*ctype20[6]={"newspace", "namespace", "asm","pascal","throw","template" },
	*ctype21[9]={"virtual","volatile","near","far","huge","interrupt","cdecl","_cdecl","__cdecl"},
	*ctype22="operator",  *ctype23[2]={"auto","register"};

const StyleVal fervorLad[c_style_count+1]={
{ colorVal(2, 85, 9 ), true, false, false },
{ colorVal(0x3c, 0x26, 0x71),  true, false, true },
{ colorVal(40, 78, 255), true, false, false },
{ colorVal(142, 0, 0), true, false, false },
{ colorVal(9, 9, 0xa0), true, false, false},
{ colorVal(9, 9, 0xa0),true, false, false },
{ colorVal(9, 9, 0xa0), true, false, false}, // 6
{ colorVal( 142,0,0 ),true, false, false} ,
{ colorVal( 9, 9, 0xa0 ), true, false, false}, 
{ colorVal(19, 58, 19), true, false, false}, 
{ colorVal(0xb0, 0x70, 0x35),false, false, false},
{ colorVal( 108, 58, 15),true, false, false},
{ colorVal(0x40, 0x80, 0x10),  true, false, false},// 12
{ colorVal(65, 20, 8), true, false, false },
{ colorVal( 9, 9, 0xa0 ),true, false, false },
{ colorVal(0xEA, 0x23, 0xa ), true, false, false } ,
{ colorVal(0x10, 0x12, 0x60),true, false, false},
{ colorVal( 77, 0, 9), true, false, false } ,
{ colorVal(0x72, 0xab, 0x27), true, false, false },  // enum
{ colorVal(0, 102, 102 ),true, false, false},
{ colorVal(0, 150, 150),true, false, false},
{ colorVal( 0, 59, 79 ),true, false, false},
{ colorVal(0, 200, 200), true, false, false}, 
{ colorVal(8, 0xa0, 20), true, false, false },
{ colorVal(0xc8, 0x20, 0x18), true, false, true }
};

const StyleVal WRAM[c_style_count+1]={
{ colorVal(0, 102, 102 ), true, false, true },
{ colorVal(0xb0, 0x20, 0x19), true, false, false},
{ colorVal(0x1a, 0x12, 0xa0),true, false, false },
{ colorVal(40, 78, 255), true, false, false},
{ colorVal(0x30, 0x70, 0x8), true, false, false},  // colorVal(0x5a, 0x97, 0x4e)
{ colorVal(0x30, 0x70, 0x8), true, false, false },
{ colorVal(0x30, 0x70, 0x8), true, false, false}, // 6
{ colorVal(40, 78, 255), true, false, false},
{ colorVal(0x30, 0x70, 0x8), true, false, false},
{ colorVal(90, 24, 26), true, false, false}, 
{ colorVal(0, 158, 180), true, false, false },
{ colorVal( 0, 0x80, 40 ), true, false, false},
{ colorVal(0, 0x10, 0x80), true, false, false},  // 12
{ 0xa84040, true, false, false },
{ colorVal( 9, 9, 0xa0 ), true, false, false },
{ 0xe0310a, true, false, false },
{ colorVal(2, 90, 25), true, false, false},
{ colorVal(87, 10, 10), true, false, false } ,
{ colorVal(0, 72, 72), true, false, true },  // enum
{ colorVal(0, 50, 68 ), true, false, true},
{ colorVal(4, 0xb0, 20), true, false, false},
{ colorVal(108, 58, 18), true, false, false},
{ colorVal(40, 0x28, 0x9a), true, false, false},
{ colorVal(220, 20, 10), true, false, false },
{ colorVal(0xc8, 0x20, 0x18), true, false, true }
};

const StyleVal *_colors[cs_modul_cnt]={ fervorLad, WRAM };

const unsigned int lineStyle[cs_modul_cnt][3]={
	{ 0x884040, 0x808080, 0x55974e },
	{ colorVal(0, 58, 89), 0x838398, 0x539038 },
};

static const char _std[]=" \t\n";
TxtStyle freeStyles[c_style_count+1]={
{"duiepl",  "# \t", " \t", 6,3,2,11 },
{"i",  "# \t",  " \"<\t", 1, 3, 4, 1 },
{"clvsufdbi"," ;,:(<{}<\t", " ,*(>)}\t", 9, 10, 8, 13 },
{ "r",  " \t;{}):", "; \t)(", 1, 7, 5,  1 },
{"e",  " \t};", " \t{", 1, 4,3, 1 },
{"d",  " \t;}", " \t:", 1, 4,3, 1 },
{"c",  " \t;{}", " \'\t" , 1, 5,3, 1 },
{"bcg", " :\t{});/", " \t;", 3, 8, 3, 3 },
{"wifsc",  " \t:;{})", "( \t", 5,7,3, 5 },  // 8
{"esf", " ;,:({<\t", " \t", 3,8, 2, 3 },
{"tf",  "/= \t?{(,:&|!;",  "/,;)}&| \t:", 2,13, 10,2 },
{"_c",  " ;,:({<\t", "; \t", 2, 8, 3,2 },
{"n",  " \t:(){},;=", " \t", 1,10, 2,1 }, // 12
{"d",  " \t:{});", " \t", 1,7, 2,1 }, 
{ "td",  " \t{};:" , " {\t", 2,6, 3,2 },
{ "s",  " \t=:([+-*/%|&><,", " \t(", 1,16, 3,1 },
{"t",  " \t=:()[|&,;/*" ,   "/,; \t&!-|)]", 1,13, 11 ,1},
{"ps",  "{; \t:", " \t:", 2,5, 3, 4 },
{"ie",  " \t;", " \t" , 2, 3,2,2 },
{"t",  " \t;", " \t" , 1, 3,2, 1 },
{"napt",  ";{ \t", " \t<" , 4, 4,3, 6 },
{"vnfhic_",  " \t:{};", " \t", 7,6,2,9 },
{"o",  " \t:{});", "!=&<>| \t", 1, 7, 8,1},
{"ra",  " ;,:({<\t", " \t", 2, 8, 2,2 },
{ NULL, ",;: \t", "( \t", 1,5,3,1 }
};

const char **_CType[c_style_count+1]={
	ctype0,	&ctype1,
	ctype2,	&ctype3,  &ctype4, &ctype5, &ctype6,
	ctype7, ctype8,
	ctype9, ctype10, ctype11,
	&ctype12, &ctype13, ctype14,
	&ctype15,&ctype16,ctype17,
	ctype18,&ctype19,ctype20,
	ctype21, &ctype22, ctype23
}; // CType take relation of freeStyles, so don't change them.

/*****************************************************/
const unsigned int logLineStyle[3]={ 0xb0510a, 0x838398, 0x56964d };
static const char *log_nat="China", *logp[3]={ "France", "Japan", "USA" };
const char **logKeys[log_style_count]={
//	ctype0,	&ctype1,
	&log_nat,  logp
};//="☆★";

const TxtStyle logStyles[log_style_count]={
{"C", _std,  _std, 1, 3, 3, 1 },
{"FJU", _std, " \t\n,.", 3, 3, 5, 3 }
};

const StyleVal logColor[log_style_count]={
{ colorVal(230, 50, 20),  true, false, false },
{ colorVal(30, 50, 220), true, false , false },
//{ colorVal(20, 150, 20), true, false, true },{ colorVal(200, 90, 10), true, false, true }
};


/**************************************************************/
const unsigned int rlsLineStyle[3]={ 0xa0510a, 0x787870, 0x56964d };
const char *Tfsp0[7]={ "mkrose", "mkdir", "numbset", "impcreat", "import", "setdscpt", "exe" },
	*Tfsp1[12]={ "close", "del", "rm", "erase", "rmdir", "export", "exit", "quit", "end", "abort", "rmdscpt", "rebuild" },
	*Tfsp2[7]={"insert", "write", "add", "append", "select", "read", "cd" },
	**rlsKeys[rls_style_count]={
	Tfsp0,	Tfsp1,	Tfsp2,
	};

const TxtStyle rlsStyles[rls_style_count]={
{"mnise", _std, _std, 5, 3, 3, 7 },
{"cdreqa", _std, _std, 6, 3, 3, 12 },
{"iwasrc", _std, " \t\n.", 6, 3,4, 7 }
};

const StyleVal rlsColor[rls_style_count]={
{ colorVal(13, 50, 13),  true, false, true },
{ colorVal(10, 50, 220), true, false , false },
{ colorVal(18, 15, 120), true, false, false }
};
