/*
	Designed & modify by Linjianghua
	Free under LGPL
*/

//----------- version 1.3 ------------
#include "fastblock.h"

FastBlock::FastBlock(int m, int limit) : _FastBlock(m, limit)
{
}

FastBlock :: FastBlock(char *dat, const char *div, int m, int l) :
	_FastBlock(m, l)
{
// buf=NULL; list=NULL; mode=m;	lmt=l;
_resetMem(dat, div);
}

FastBlock :: FastBlock(char **lst)
{
lmt=0x7ffffff0;
mode=AllNoFree;
list=lst;
}

FastBlock :: FastBlock(FastBlock & chslst)
{
buf=NULL;
list=NULL;
copy(chslst);
// normal call memDiv(...) after use this
}

/*FastBlock::~FastBlock()
{
_FastBlock::~_FastBlock();
}*/

void FastBlock :: copy(FastBlock & lst)
{// normal call memDiv(...) after use this
_resetMem(NULL);
len=lst.len;
buf=(char *)malloc(len);
memcpy(buf, lst.buf, len );
lmt=lst.lmt;
mode=lst.mode;
if(mode>OnlyAdd)cnt=lst.cnt;
//mcnt=mlst->mcnt;
}

int FastBlock::add(const char *txt, const char *d)
{
if(txt==NULL)return -1;
return _FastBlock::add(txt, d);
}

void FastBlock::remove(int idx)
{
if(idx<cnt){
int i, j=0, nls=0;
char *ptxt, *tmp, **tmps;
alen=len;
mcnt=cnt+2;
if(mcnt>lmt)mcnt=lmt+1;
tmps=(char **)malloc(mcnt*sizeof(char **));
len-=strlen(list[idx])+1;
tmp=(char *)malloc(alen);
*tmp=0;
for(i=0;i<cnt;i++)if(i!=idx){
	tmps[nls++]=tmp+j;
	ptxt=list[i];
	for(register int n=0; ptxt[n]; n++)tmp[j++]=ptxt[n];
	tmp[j++]=0;
	}
tmps[--cnt]=NULL;
free(list); free(buf);
list=tmps;
buf=tmp;
}
}

void FastBlock::insert(const char *txt, int idx)
{
int i,  j, nls, count;
char *ptxt, *tmp, **tmps;
if(idx<cnt)count=cnt++;
else {
	idx=cnt++;
	count=cnt;
	}
len+=strlen(txt)+1;
alen=len+2;
mcnt=cnt+1;
// if(mcnt>lmt)mcnt=lmt+1; wait 2014-8-24
tmps=(char **)malloc(mcnt*sizeof(char **));
// len-=strlen(list[idx])+1;
tmp=(char *)malloc(alen);
*tmp=0;
j=0;	nls=0;
for(i=0;i<count;i++){
	register int n;
	if(i==idx){
	  tmps[nls++]=tmp+j;
	  for(n=0; txt[n]; n++)tmp[j++]=txt[n];
	  tmp[j++]=0;
	  if(count==cnt)break;
	}
	tmps[nls++]=tmp+j;
	ptxt=list[i];
	for(n=0; ptxt[n]; n++)tmp[j++]=ptxt[n];
	tmp[j++]=0;
}
tmps[cnt]=NULL;
free(list); free(buf);
list=tmps;
buf=tmp;
}

void FastBlock::sort( bool a, bool cs )
{
int i, j, t=cnt-1;
char *pt;
sortTag=a;
for(i=0; i<t; i++)
  for(j=i+1; j<cnt; j++)
	if( ( namcmp( list[i],list[j], cs )>0 ) == a ){
		pt=list[i];		list[i]=list[j];
		list[j]=pt;	
		}
}

int FastBlock::find(const char *dat)
{
int i;
if(cnt==0)return -1;
for(i=0;i<cnt&&strcmp(list[i],dat);i++);
return i<cnt ? i :-1;
}

