/*
    林江华编写，2010-2，Copyright LinJiangHua
    Free under LGPL
*/

#include <fcntl.h>
#include <pthread.h>
#include <qtooltip.h>
#include <qtimer.h>
#include <qtoolbutton.h>
#include "filesan.h"
#include "treeview.h"
#include "xfun.h"
#include "cfun.h"
#include "dirloop.h"
#include "conspace.h"
#include "orlcon.h"
#include "orlattr.h"

#include "orltree.cpp"

const char slot_doRen[]=SLOT(doRen()), sig_doRen[]=SIGNAL(itemRenamed(QListViewItem*,int)),
	sig_dSelChange[]=SIGNAL(selectionChanged(QListViewItem *)),	slot_dSelChange[]=SLOT(chDirSel(QListViewItem*)),
	sig_expand[]=SIGNAL(expanded(QListViewItem *)),
	slot_expand[]=SLOT(dirExpand());

const char doRen[]=SLOT(dirDoRen()), fastdiv[]=",",
	slot_enter[]=SLOT(dirEnter(QListViewItem*)),
	sig_enter[]=SIGNAL(returnPressed(QListViewItem*));

TreeView::TreeView(QWidget *wdg, int id, Filesan *fs) : ListContent(wdg, treeViewChs, id, fs),
	_Params(__params), fsRootItem(NULL),
	seekDirMsg(false), subDirCreat(true),
	lostTag(false), skpslot(false),
	recentORL(NULL)
{
filesor=fs;	fs->vDir=winId();
header()->hide();
addColumn(_Spc);
setSorting(-1);
// setSelectionMode(Single);
setPaletteBackgroundColor(0xe2e8e8);
setDefaultRenameAction( QListView::Accept );
connect(this, sig_doRen, filesor, doRen ); // 防误击引发改名，要与_filelist区分 connect(this, sig_enter, this, slot_enter );
connect(this, sig_dSelChange, this, slot_dSelChange );
connect(this, sig_enter, this, slot_enter );
connect(this, sig_expand, this, slot_expand );
// connect(this, SIGNAL(collapsed(QListViewItem*)), this, SLOT(collap()));
}

void TreeView::treeDel(LVItem *it)
{
LVItem *par=(LVItem *)it->parent();
if(par)par->takeItem(it);
else takeItem(it);
filesor->delLVItem(it);
}

LVItem *TreeView::seekDir(const char *path, int msg, const char *dst)
{
char *dnam, *pt, tmp[strlen(path)+2];
LVItem  *it=NULL, *par;
int i, sw=ReadComm(msg);
strcpy(tmp, path);
bool rt=false;
if(sw==SHOW_LIST/*!=TEST_REMOVE_DIR&&sw!=REMOVE_DIR*/){
	const char *fit;
	if( (rt=divFileName(tmp, &fit))==false)goto _skp_;
	if(msg&COMBENTER){
		if(filesor->Filter)free((void *)filesor->Filter);
		filesor->Filter=fit;
	}
	filesor->setCWD(tmp, msg/*|DIRECT_LIST*/);
}
it=(LVItem *)selectedItem();
switch(filesor->modul){
case _PLACE : 
	if(it==NULL){
_re_seek_:	it=(LVItem *)firstChild();
		while( it && strstr(tmp,it->fnam)!=tmp )
			it=(LVItem *)it->nextSibling();
		if(it==NULL)return NULL;
//		else setSelected(it, true); // will toggle slot(...)
	}
	else {
		while(it->parent())it=(LVItem *)it->parent();
		if(strstr(tmp, it->fnam)!=tmp)goto _re_seek_;
	}
	i=strlen(it->fnam);
	pt=i>1 ? tmp+i : tmp;
	subDirCreat=false;
	if(*pt==0)goto _selItem_;
	break;
case _FASTTAGS :
	if(it==NULL || it==(LVItem *)firstChild()){
_re_seek2_: it=(LVItem *)firstChild()->firstChild();
	    for(i=taglst.count()-1; i>-1&&strstr(tmp, taglst.lstIndex(i))!=tmp; i--)it=(LVItem *)it->nextSibling();
	    if(i<0)goto _skp_;
	}
	else {
		while(it->parent()!=firstChild())it=(LVItem *)it->parent();
		par=(LVItem *)firstChild()->firstChild();
		for(i=taglst.count()-1; i>-1&&it!=par; i--)par=(LVItem *)par->nextSibling();
		if(strstr(tmp, taglst.lstIndex(i))!=tmp)
			goto _re_seek2_;
	}
	i=strlen(taglst.lstIndex(i));
	pt=i>1 ? tmp+i : tmp;
	subDirCreat=false;
	if(*pt==0)goto _selItem_;
	break;
case _OSROOT : it=(LVItem *)firstChild(); // root
	pt=tmp;
	break;
case _OPENROSE : filesor->ORL_infor(ORD);
default : return NULL;
}
subDirCreat=false;
_start_ : dnam=pt+1;
while(*dnam=='/')dnam++;
if( pt=strchr(dnam, '/') )*pt=0;
par=it;
if(*dnam==0) goto jmp;
for( it=(LVItem *)it->firstChild(); it; it=(LVItem *)it->nextSibling() )
	if(strcmp(dnam, it->fnam)==0)
		jmp: switch(sw){
		case SHOW_TREE_LIST : // SHOW_LIST, 两者是List MainView先后不同
		case SHOW_TREE_ORDER : // 只定位目录
		case SHOW_LIST :
			if(pt){
				for(i=0; tmp+i<dnam; i++)if(tmp[i]==0)tmp[i]='/';
				if(it->isOpen()==false){
					seekDirMsg=true;
					it->setOpen(true);
					filesor->setCWD(tmp, SHOW_SUB_TREE , it);
				}
				goto _start_;
			}
			else if(it!=(LVItem *)selectedItem()){
		_selItem_:	ensureItemVisible(it);
				if(sw!=SHOW_TREE_LIST)disconnect(this, sig_dSelChange, this, slot_dSelChange );
				setSelected(it,true);
				if(it==(LVItem *)firstChild()||cfg_moreShow){
					if(it->isOpen()==false)it->setOpen(true);
					}
				if(sw!=SHOW_TREE_LIST)connect(this, sig_dSelChange, this, slot_dSelChange );
				}
			goto _ex_;
		case TEST_REMOVE_DIR : // test it exist ( is dir ? )
		case REMOVE_DIR :
		case TEST_GETITEM :
		case GETITEM : 
		case FRENAME :
			if(pt)goto _start_;
			switch(sw){
			case TEST_REMOVE_DIR :  // test it exist ( is dir ? )
			case REMOVE_DIR : 
				treeDel( it );
				// treeLostDel(it); // safe, no thus! as this time not selected(current) ...
				goto _ex_;
			case FRENAME :
				free(it->fnam);
				it->fnam=strdup(dst);
				it->setText(0, filesor->_toUnicode(dst));
			case TEST_GETITEM :
			case GETITEM : goto _ex_;
			}
	}

_skp_:	if(sw<TEST_GETITEM/*&&modul==_OSROOT => SHOW_... */)
	  if(rt==false)
		statusBarMsg(filesor->bottomPanel, noneFile, path, 0x902019);
	  else switch(filesor->modul){
		case _PLACE :
		case _FASTTAGS : 
			if( (it=(LVItem *)selectedItem()) )setSelected(it, false);
			break;
		default : i=getMode(path, NULL); 	 // 目录存在，但在左视图中已有的子节点中仍未有，一般是失效的链接重新在console中链接
			it=newDirItem(path, freqIco[(i&1023) <3  ? (i&1023)+DIR_OFF : i&1023], 0 );
			goto _selItem_;
		}
_ex_: subDirCreat=true;
return it;
}

void TreeView::selPart(LVItem *it, char *dat, int i)
{
int t, Idx=listViewIndex( this,  it);
if(Idx>-1){
	char *pt=filesor->pdklst.lstIndex(Idx), buf[strlen(pt)+2];
	FastBlock lst(NoFree);
	strcpy(buf, pt);
	lst.add(buf, fastdiv);
	t=lst.count()-1;
	if(dat)strcpy(dat, lst.lstIndex(i));
	else if(strcmp(filesor->dirNam, lst.lstIndex(t)) ){
		filesor->setCWD(lst.lstIndex(t), SHOW_LIST, NULL);
		filesor->PreCopyStats();
		}
}
}

LVItem *TreeView::newDirItem(const char *pthnam, const QPixmap *pix, int estIt )
{
LVItem *it=NULL;
char  *pt, *dirnam=strdup(pthnam);
if( pt=strrchr(dirnam, '/') ){
	if(pt[1]=='.')goto _ex_;
	*pt++=0;
	LVItem *par=seekDir(dirnam,TEST_GETITEM);
	if(par){
		LVItem *after=NULL;
		it=(LVItem *)par->firstChild();
		if(estIt==0){ // not eixst
		  while( it && (namcmp(pt, it->fnam, pms_case)>0) == (pms_treeDescend>0) ){
			after=it;
			it=(LVItem *)it->nextSibling();
			}
		  if( it &&strcmp(pt, it->fnam)==0)goto _ex_;
		  it=new LVItem(par, after, pt );
		  filesor->subDirs(dirnam, it, SHOW_TREE_THR );
		}
		else while( it && strcmp(it->fnam, pt) )it=(LVItem *)it->nextSibling();
		if(it){
			it->setPixmap(0, *pix);
			it->setRenameEnabled(0,true);
		}
	    }
}
_ex_: free(dirnam);
return it;
}

void TreeView::treeRemove(LVItem *it)
{
treeDel(it ? it : sendItem);
lostTag=false;
setSelected(currentItem(), true);
}

void TreeView::treeLostDel(LVItem *it)
{
	sendItem=it;
	lostTag=true;
	lostId=startTimer(200);
}

//return: 0正确, 否则 enum FILE_TEST { }, only for treeview
int TreeView::setTreeDir(LVItem *tvIt, int Msg)
{// in treeview
filesor->busiedCursor();
char *pth=filesor->modul!=_FASTTAGS ? treeFullPath(tvIt) : tagFullPath(tvIt);
struct stat64 st;
int  rt;
switch( rt=isExist(pth, &st) ){
case symLink : 
case 0 : if( (rt=filesor->setCWD( pth, Msg, tvIt))==no_Right )filesor->clearView();
	break;
// case lost_Link : rt=1; // 虚指，一般不出现于treeview;
//	break;
// case none_File :
default : filesor->CurDirMode=0;
}
free(pth);
filesor->normalCursor();
return rt;
// 0正确, other is FILE_TEST::
}

int TreeView::setItemCurDir(LVItem *it)
{
int t;
filesor->fsKillTimer();
t=setTreeDir(it, cfg_moreShow ? SUB_TREE_LIST : SHOW_TREE_LIST);
switch( t ) {
case lost_Link : 	//虚指
case none_File : 	statusBarMsg(filesor->topPanel, noneFile, it->fnam, 0xa02018, 1|4);
	if(filesor->modul==_FASTTAGS&&it->parent()==firstChild()){
		filesor->clearView();
		filesor->pathComb->setCurrentText(NULL);
		it->setPixmap(0,*selectTagPix(ICO_LOSTTAGS));
		}
	else treeLostDel(it);
	break;
case no_Right : statusBarMsg(filesor->bottomPanel, noRight, it->fnam, 0x901818);
//	break;
//case symLink :
//case 0 : 	// if(dropTim) it->setOpen(true);
	}
filesor->fsStartTimer();
return t;
}

int listViewIndex(QListView *lvw, LVItem *it) // treeview only place
{
int idx;
LVItem *it1=(LVItem *)lvw->firstChild();
if(it1==NULL||it==NULL)return -1;
for(idx=0; (it1 && it1!=it ); idx++)it1=(LVItem *)it1->nextSibling();
return it1==it? idx : -1;
}

#include "mount.c"

void TreeView::takeFS()
{
	selDir=(LVItem *)selectedItem();
	if(!selDir)selDir=(LVItem *)currentItem();
	fsRootItem=(LVItem *)firstChild();
	takeItem(fsRootItem);
}

// ---------------------- tag ---------------------------
void TreeView::creatTagItem(int i, int sort)
{
    LVItem *it, *af=NULL, *par=(LVItem *)firstChild();
    char *pt=tagNamlst.lstIndex(i);
    if(sort)for(it=(LVItem *)par->firstChild(); it; it=(LVItem *)it->nextSibling())
	if( (namcmp(it->fnam, pt, pms_case)>0)==(sort>0) ){
		af=it;	break;
		}
    it=new LVItem(par, QString::fromUtf8(pt) );
    if(strcmp(home, taglst.lstIndex(i))==0)it->setPixmap(0, *freqIco[ICO_HOMEDIR]);
    else it->setPixmap(0, *selectTagPix(filesor->filePixmap(taglst.lstIndex(i)) ) );
    if(af)it->moveItem( af );
    it->setRenameEnabled(0, true);
    filesor->setCWD(taglst.lstIndex(i), SHOW_TREE_ORDER, it); // not SHOW_TREE_THR
}

char *TreeView::tagFullPath(LVItem *it)
{
LVItem *par;
char *tmp, *pt=NULL;
if(it && (par=(LVItem *)it->parent()) ){
int t, n=0;
FastBlock lst(__AppenAlone);
while(par!=firstChild()){
	lst.add(it->fnam);
	it=par;	n++;
	par=(LVItem *)par->parent();
	}
par=(LVItem *)firstChild()->firstChild();
for(t=taglst.count()-1; t>-1&&it!=par; t--)par=(LVItem *)par->nextSibling();
tmp=taglst.lstIndex(t);
t=strlen(tmp);
pt=(char *)malloc(lst.length()+t+n+4);
strcpy(pt, tmp);
pt[t++]='/';
lst.memDiv(0);
for( n=lst.count()-1; n>-1; n--){
	strcpy(pt+t, lst.lstIndex(n) );
	t=strlen(pt);
	pt[t++]='/';
	}
pt[t-1]=0;
}
return pt;
}

LVItem *TreeView::sortItem(LVItem *tk, int sort, const char *nam)
{
LVItem *itm, *T, *bm;
if(tk->firstChild()){
    bool exp=tk->isOpen();
    bm=new LVItem(this, tk, nam);
    bm->setPixmap(0, *tk->pixmap(0));
    while( (itm=(LVItem *)tk->firstChild())!=NULL ){
	T=itm;
	while( (itm=(LVItem *)itm->nextSibling() ) )
		if( (namcmp( T->fnam, itm->fnam, pms_case)>0)==(sort>0) )T=itm;
	bm->insertItem(T);
   }
   delete tk;
   bm->setOpen(exp);
   return bm;
}
return tk;
}

void TreeView::createTags()
{
int i;
clear();
LVItem *bm=new LVItem(this, QString::fromUtf8(tagsRoot));
filesor->modul=_FASTTAGS;
bm->setOpen(true); // will change CurDirMode
bm->setPixmap(0, *pixmapLoad(fastTagsImg));
for(i=0; i<tagNamlst.count(); i++)creatTagItem(i, 0);
}

// ------------------------- end tag -----------------------

QMetaObject *TreeView::metaObj = 0;
static QMetaObjectCleanUp dirViewCleanUp( treeViewChs, &TreeView::staticMetaObject );
QMetaObject *TreeView::staticMetaObject()
{
  if ( !metaObj ){
    static const QMetaData slot_tbl[] = {
	{ "dirExpand()", &slot_ptr, QMetaData::Private }, 
	{ "dirEnter(QListViewItem*)", &slot_ptr,  QMetaData::Private },
	{ "ORLattr()", &slot_0_0, QMetaData::Private },
	{ "place()", &slot_0_0, QMetaData::Private },
	{ "ORose()" , &slot_0_0, QMetaData::Private },
	{ "fastTags()", &slot_0_0, QMetaData::Private },
	{ "treeDescend()" , &slot_0_0, QMetaData::Private },  // 6
	{ "dirNoSort()" , &slot_0_0, QMetaData::Private },
	{ "openORL()", &slot_0_0, QMetaData::Private },
	{ "moreShow()" , &slot_0_0, QMetaData::Private },
	{ "mntiso()" , &slot_0_0, QMetaData::Private },
	{ "mntsquashfs()" , &slot_0_0, QMetaData::Private },
	{ "unmount()",&slot_0_0, QMetaData::Private },
	{ "closeORL()", &slot_0_0, QMetaData::Private },
	{ "chDirSel(QListViewItem*)", &slot_ptr,  QMetaData::Private }, // 14
	{ "remnt()",&slot_0_0, QMetaData::Private },
	{ "trymnt()",&slot_0_0, QMetaData::Private }
	};
    metaObj = QMetaObject::new_metaobject(treeViewChs, ListContent::staticMetaObject(), slot_tbl, 17,
	0, 0,
#ifndef QT_NO_PROPERTIES
	0, 0,
	0, 0,
#endif // QT_NO_PROPERTIES
	0, 0 );
    dirViewCleanUp.setMetaObject( metaObj );
}
return metaObj;
}

void TreeView::updateParts()
{
#define  OldTag  1
	bool fresh;
	int i=0;
	char *nam, *pt;
	FastBlock lst, *plst=&filesor->pdklst;
	LVItem *it=(LVItem *)firstChild(), *cmp, *sel;
	if(sel=(LVItem *)selectedItem()){
		while(sel->parent())sel=(LVItem *)sel->parent();
		}
	while(it){
		it->setTypeOr(OldTag);
		it=(LVItem *)it->nextSibling();
		}
	setRootIsDecorated(true);
	it=NULL;
	while( i< plst->count() ){
		lst.resetMem(strdup(plst->lstIndex(i)), ",");
		nam=strrchr(lst.lstIndex(0), '/')+1;
		for(cmp=(LVItem *)firstChild(); cmp; cmp=(LVItem *)cmp->nextSibling())
			if(strcmp(cmp->text(0), nam)==0){
				it=cmp;
				it->setTypeOr(0);
				goto _skp_;
			}
		it=new LVItem(this, it, nam);
		it->setPixmap(0,*pixmapLoad(disk32Img));
		pt=lst.lstIndex(lst.count()-1);
		it->_setName(pt);
		filesor->setCWD(pt, SHOW_TREE_ORDER, it);
	_skp_: i++;
	}
	filesor->modul=_PLACE;
	it=(LVItem *)firstChild();
	fresh=false;
	while(it){
		cmp=(LVItem *)it->nextSibling();
		if(it->getTypeOr()==OldTag){
			if(it==sel)fresh=true;
			treeDel( it );
			}
		it=cmp;
		}
	if(fresh/*&&currentItem()*/){
		setSelected(currentItem(),true);
}
#undef  OldTag
}

void TreeView::exeMount(const char *pt)
{
filesor->fsKillTimer();
clear();
filesor->updateDrivers();
if(pt){
	LVItem *it=(LVItem *)firstChild();
	while(it){
	  if(strcmp(it->fnam, pt)==0){
		seekDir(filesor->dirNam, SHOW_TREE_ORDER/*RESHOW_LIST*/, NULL);
		break;
		}
	  it=(LVItem *)it->nextSibling();
	}
}
filesor->disktime=8; // update at once in filesor->event(), list againt for mount just
// if(uId==0)filesor->updateDrivers(false);
filesor->fsStartTimer();
}

void TreeView::treeSort(int Msg)
{
filesor->fsKillTimer();
switch(filesor->modul){
case _OSROOT : {
	bool exp=currentItem()->isOpen();
	clear();
	filesor->setCWD( "/",  INIT_DIRVIEW, NULL /* only get dir */);
	seekDir(filesor->dirNam, Msg);
	if(exp)currentItem()->setOpen(true);
	}
	return;
case _FASTTAGS :  	sortTagsList(pms_sorttag);
		sortItem((LVItem *)firstChild(), pms_sorttag, tagsRoot);
		break;
case _PLACE : {
	LVItem *it;
	if((it=(LVItem *)selectedItem())){
		while(it->parent())it=(LVItem *)it->parent();
		char *pt=strdup(it->fnam);
		exeMount(pt);
		free(pt);
		}
	else exeMount(NULL);
	}
	break;
case _OPENROSE : sortSub();
}
if(fsRootItem){
	delete fsRootItem;
	fsRootItem=NULL;
}
filesor->fsStartTimer();
}

struct ThreadParas {
Filesan *fs;
const char *dirNam;
LVItem *item;
};

void *subExpand(void *send)
{
  ((ThreadParas *)send)->fs->setCWD(((ThreadParas *)send)->dirNam, SHOW_TREE_THR, ((ThreadParas *)send)->item);
  free((void *)((ThreadParas *)send)->dirNam);
  free(send);
  return NULL;
}

bool TreeView::qt_invoke(int id, QUObject *quo)
{
int i, M=filesor->modul,
	sw=id - staticMetaObject()->slotOffset();
LVItem *it;
bool exp;
char  *pt=NULL, *cmd, *tmp;
switch(sw){
   case 0 : 
   case 1 : switch(M){
	case _OSROOT : if(seekDirMsg){
				seekDirMsg=false;
				return false;
			}
	case _PLACE :
	case _FASTTAGS : 
	case _OPENROSE :
		filesor->fsKillTimer();
		filesor->busiedCursor();
		it=(LVItem *)(quo[1].payload.ptr);
		if(sw==1){
		    exp=it->isOpen();
		    it->setOpen(!exp);  // press enter
		    if(exp)goto _jmp_;
		}
		if(M==_OPENROSE){
			__ORD *dir=selORD(it, NULL, 2);
			ORDclose(dir,1);
			}
		else {
			if(subDirCreat&& !(it==firstChild()&&M==_FASTTAGS) )
				setTreeDir( it, SHOW_TREE_ORDER );
//			dirExpanding( it );
			LVItem *itm, *nx;
			switch(filesor->modul){
			case _PLACE :
			case _OSROOT : tmp=treeFullPath(it);
				break;
			case _FASTTAGS : if(// it==firstChild() ||
				(tmp=tagFullPath(it))==NULL )goto _jmp_; 
			}
			for(itm=(LVItem *)it->firstChild(); itm; itm=nx){
			    nx=(LVItem *)itm->nextSibling();
			    if(itm->childCount()==0){
				ThreadParas *pms=(ThreadParas *)malloc(sizeof(ThreadParas));
				pms->dirNam=catstr(tmp, itm->fnam, '/');
				pms->fs=filesor;
				pms->item=itm;
				doThread(PTHREAD_STACK_MIN+600*sizeof(void *), subExpand, pms);
		    	    }
			}
			free(tmp);
		}
_jmp_:	filesor->fsStartTimer();
	filesor->normalCursor();
	}
	break;
    case 5 : // click FastTag
	switch(M){
	case _FASTTAGS : 
		goto _setFS_;
	case _OSROOT : takeFS();
		goto _FastTags_;
	case _OPENROSE : filesor->closeORlist();
		goto _FastTags0_;
	case _PLACE : filesor->leavePlace();
	_FastTags0_:	setRootIsDecorated(false);
	_FastTags_:	createTags();
	}
	break;
    case 4 : // click OpenRose
	switch(M){
	case  _OPENROSE : filesor->closeORlist();
		goto _setFS0_;
	case  _FASTTAGS : filesor->fastTagsBtn->setOn(false);
		goto _ORose_;
	case  _OSROOT : takeFS();
		goto _ORose_;
	case  _PLACE : filesor->leavePlace();
	_ORose_: createOpenRose(true);
		filesor->creatORLList();
	}
	break;
    case 3 :  // click Place
	switch(M){
	case _OPENROSE : filesor->closeORlist();
		goto _mount_;
	case _FASTTAGS : filesor->fastTagsBtn->setOn(false);
		goto _mount_;
	case _OSROOT :
		takeFS();
	_mount_: exeMount(NULL);
		break;
	case _PLACE : _setFS0_:
		filesor->leavePlace();
		setRootIsDecorated(false);	
		_setFS_:	filesor->modul=_OSROOT;
		clear();
		if(fsRootItem){
		  insertItem( fsRootItem );
		  if(strstr(filesor->dirNam, "/.")==NULL){
			pt=treeFullPath(selDir);
			if(strcmp(pt, filesor->dirNam)){
			    i=setItemCurDir(selDir);
			    if(i && i!=symLink)goto _mod_;
			}
		  }
		  else pt=NULL;
		  ensureItemVisible(selDir);
		  setSelected(selDir, true);
		  if(pt)_mod_:free(pt);
		}
		else filesor->modulsInit(false);
	}
	break;
    case 12 : {
	char buf[560], d[512];
	selPart((LVItem *)currentItem(), d, 0 );
	sprintf(buf, "umount %s", d );
	if(system(buf)){
		strcat(buf, umountFail);
		QApplication::beep();
		statusBarMsg(filesor->bottomPanel, buf, _Spc, 0x700606);
		}
	else {
		unmount.add(d);
		filesor->updateDrivers();
		}
	}
	break;
   case 13 : {
	__ORD *dir=itemORD((LVItem *)currentItem());
	__ORL *orl=isNormDir(dir) ? dir->lib : (__ORL *)dir;
	if(orl->openMode&OpenAlway)filesor->stBar()->showMsg(alwayOpen, 99, 1, 0x700303);
	else {
		ORLreleas( orl, menuPlusDo );
		filesor->ORLtm=6;
		}
	}
	break;
   case 14 : // move   up or down
	it=(LVItem *)quo[1].payload.ptr;
	filesor->fsKillTimer();
	filesor->busiedCursor();
	filesor->holdWait();
	switch(M){
	case _OPENROSE :	if(skpslot==false)chORD(it);
			skpslot=false;
		break;
	case _FASTTAGS : if(it==(LVItem *)firstChild())break;
	case _PLACE : 
	case _OSROOT :
		i=setItemCurDir( it );
		if(i==0 || i==symLink){
		    if(M==_PLACE)selPart(it);
		    else if(cfg_moreShow){
			if(it->isOpen()==false)it->setOpen(true);
			}
		}
	}
	filesor->fsStartTimer();
	filesor->normalCursor();
	break;
   case 15 : unmount.resetMem(NULL);
   case 16 : filesor->disktime=0;
	noUseDisk.resetMem(NULL);
//	filesor->updateDrivers(false);
	{
	FastBlock *plst=&filesor->pdklst, tmp;
	doMount(plst);
	getMount(plst, tmp);
	updateParts();
	}
	break;
   case 9 : cfg_moreShow=!cfg_moreShow;
	break;
   case 2 : {
	for(i=0; i<orlAtts.count(); i++)
		if(orlAtts.at(i)->cmp(ORD)){
			orlAtts.at(i)->showTop();
			return true;
			}
	(new ORLattr(filesor, ORD))->execu( 25,  29 , 11 );
	}
	break;
   case 8 : recentORL=ORLspac(filesor->currentItemPath(), (OpenSpace)(CompactMsg|ORLerror|HasFullPath), -1);
	filesor->ORLtm=6;
	break;
   case 10 : static const char *mnts[2]={ "mount -t iso9660 -o loop" , "mount -t squashfs -o loop" };
   case 11 : bool vw;
	pt=catstr(mnts[sw-10], selAsSrc.lstIndex(selAsSrc.count()-1), 32);
	vw=filesor->isViewOpera();
	tmp=vw ? filesor->curSelItemPath() : treeFullPath((LVItem *)currentItem(), false);
	cmd=catstr(pt, tmp, 32);
	free(pt);	free(tmp);
	if((i=system(cmd))==0){
		if(vw){
			if(currentItem()->childCount()){
				char *nam=filesor->_filelist ? ((LVItem *)filesor->_filelist->currentItem())->fnam :
					((IVItem *)filesor->_iconview->currentItem())->fnam;
				it=(LVItem *)currentItem()->firstChild();
				while(it){
				  if(strcmp(it->fnam, nam)==0){
					filesor->freshDirItem((LVItem *)it);
					break;
					}
				  it=(LVItem *)it->nextSibling();
				}
			}
		}
		else filesor->freshDirItem((LVItem *)currentItem());
	}
	{
		char buf[480];
		sprintf(buf, i ? failChs : OkChs, cmd);
		filesor->bottomPanel->showMsg(buf, 80, 0);
	}
	free(cmd);
	break;
     case 7 : // dirNoSort
	pms_treeDescend = pms_treeDescend==0 ? -1 : 0;
	filesor->confMenu->setItemChecked(filesor->dirNoSortId, pms_treeDescend==0);
	filesor->treeDescendBtn->setOn(pms_treeDescend<0);
	goto _sort_;
     case 6 :
	switch(pms_treeDescend){ // Sort Descend
	case -1 : 
	case 0 : pms_treeDescend=1;
		break;
	case 1 : pms_treeDescend=-1;
	}
	filesor->confMenu->setItemChecked(filesor->dirNoSortId, false);
_sort_:	treeSort(SHOW_TREE_ORDER);
	break;
   default : return ListContent::qt_invoke(id, quo);
}
return true;
}

#ifndef QT_NO_PROPERTIES
bool TreeView::qt_static_property( QObject* , int , int , QVariant* ){ return false; }
#endif // QT_NO_PROPERTIES
