/*
	Write & edit by Linjianghua(Xempo) 2004-2006, 2008-2011, 2012
	Free under LGPL
*/

#include "ordir.h"

const char rootchs[]="/";

void (*pGetPdExt)(__ORD *dir);

__ORD *ORDalloc()
{
__ORD *dir=(__ORD *)zalloc(sizeof(__ORD));
dir->mdf=FreeDirAlloc;
return dir;
}

// #ifdef  _STDIO_H
#define ZLMT  100
#define ZDIV  10
// #else

void setZero(__ORD *dir, int s)
{
if(isZero(dir->Format)){
	dir->zSize=s>0 ? s : (dir->selfnumbs<20 ? 2 : (dir->selfnumbs>1000 ? ZLMT :  dir->selfnumbs/ZDIV) );
	dir->zcache=(ZeroCache *)zalloc(  dir->zSize*sizeof(ZeroCache) );
	}
}

int getLenght(__ORD *dir)
{
return dir->DAUC * ( isType(dir->Format) ? sizeof(DAU)+1 : sizeof(DAU) )
	+ ( isZero(dir->Format) ? FCU_NumPos:FCU_NumPos+sizeof(int) );
}

__ORD *ORDparent(__ORD *dir0, char *pth, char **fixname)
{
  if(pth){
    char *dn;
/*    for(dn=pth; *dn; dn++)
	if(*dn=='\\')*dn='/';*/
    dn=(char *)separChr(pth);
    if(dn==NULL)goto _jmp_;
    if(dn!=pth)*dn=0;
    else pth=(char *)rootchs;
    *fixname=dn+1;
    return ORDopen(dir0, pth, DIR_READ);
  }
_jmp_: idxdscpt=0x7fff;
  *fixname=pth;
  if(dir0&&isNormDir(dir0))dir0->otherOpen++;
  return dir0;
}

int nameCRC(const char *dirnam)
{
static const char lmtstr[20]=
{ '\"', '*' , ';' , '\'', '?', ',', 9, 10, 13, 26, 32,':','=',
'[', ']', '<', '>', '#'   }; /* as # is datalib */
while(*dirnam=='.')dirnam++;
if(*dirnam==0||*dirnam=='-'||strchrs(dirnam,lmtstr)){ idxdscpt=InvName_13; return 0; }
return 1;
}

const un_Int PPS[pd_param_cnt]={ 0, 10, 4, 1, (1|2)/* RW */ };
void setPdPara(__ORD *dir, const un_Int *pms)
{
    if(pms==NULL)pms=PPS;
    dir->Format=*pms&(Ch_Dir-1);
    dir->Num_FCUs_Block=pms[1];
    dir->Dir_FCUs_Block=pms[2];
    dir->DAUC=pms[3] ? (pms[3]>6000 ? 6000 : pms[3]) : 1;
    dir->mode=pms[4];
    dir->mdf|=NEW_DIR;
    dir->Num_FCU_Len=getLenght(dir);
}

__ORD *ORDread(__ORL *lib, __ORD *dirbuf, DirFCU *du, dskadr_t adr, BOOL far_use)/* if far_use, generic use ORDclose(dir, 2); */
{
    int j;
    __ORD **dir=lib->usedirs;
    for(j=0; j<lib->cnt_usedir; j++)
	if(dir[j]->own_adr==adr){
		if(far_use)dir[j]->otherOpen++;
		return dir[j];
	}
    if(adr<1)return (__ORD *)lib;
    idxdscpt = dkread(lib,adr,&dirbuf->cur_numb_FCT,du? du->savelen:DIR_SAV_SIZ,1)<1 ? ErrScnFile_5:0x7fff;
    if(du)memcpy(&dirbuf->tag,du,Dir_FCU_Len);
    else dkread(lib,dirbuf->Own_FCU_Addr,&dirbuf->tag,Dir_FCU_Len,1);
/*    dirbuf->otherOpen=0; */
/*    cleanDirMdf(dirbuf); */
    dirbuf->lib=lib;
    dirbuf->Num_FCU_Len=getLenght(dirbuf);
    return dirbuf;
}

void ORDclose(__ORD *dir, int mode)
{
if(dir && isNormDir(dir)){
  int i;
  __ORL *orl;
  if(mode && dir->otherOpen ){
	--dir->otherOpen;
	return;
	}
  if(dir->mdf&63){ /* 64(FreeDirAlloc) is alloc */
     ORtime(0, dir->datebuf);
     ORDsave(dir);
  }
  orl=dir->lib;
  if(isZero(dir->Format))free(dir->zcache);
  if(dir->mdf&FreeDirAlloc)free(dir);
  for(i=0; i<orl->cnt_usedir; i++)
      if(orl->usedirs[i]==dir){
	while( i++ < orl->cnt_usedir )	orl->usedirs[i-1]=orl->usedirs[i];
	orl->cnt_usedir--;
	break;
	}
}
}

void addOpenList(__ORD *cdir)
{
if(isRoot(cdir))return;
__ORL *lib=cdir->lib;
if(lib->cnt_usedir>=lib->pre_usedir){
	lib->pre_usedir+=6;
	__ORD **usedirs=(__ORD **)malloc(sizeof(__ORD)*lib->pre_usedir);
	if(lib->cnt_usedir){
		int j;
		for(j=0; j<lib->cnt_usedir; j++)usedirs[j]=lib->usedirs[j];
		free(lib->usedirs);
	}
	lib->usedirs=usedirs;
}
setZero(cdir, 0);
lib->usedirs[lib->cnt_usedir++]=cdir;
}

__ORD *ORDopen(__ORD *cdir, const char *path_nam, int _msg)
{
if(cdir){
 __ORD *dirbuff;
 DirFCU *dunit;
 int cn, i;
 char  *pthname, **dns;
 __ORL *lib=cdir->lib;
 idxdscpt=0x7fff;
 if(path_nam==NULL||*path_nam==0){
	if(isNormDir(cdir))cdir->otherOpen++;
	return cdir;
	}
 if(*path_nam=='\\' || *path_nam=='/')cdir=(__ORD *)lib;

 dirbuff=ORDalloc();
 pthname=strdup(path_nam);	path_nam=pthname;
 cn=10000;
 dns=setargv(pthname, "/\\", &cn);
 for(i=0; i<cn; i++){
   pthname=dns[i];
/*------------------ get special path ------------------*/
   if(*pthname=='.'&&pthname[1]=='.'){
	const char *pt=pthname+2;
	while( *pt=='.' )pt++;
	if(*pt==0){ /*  othewise would like : "...abc" */
	 p_dir:	if(cdir->parent_adr<2)cdir=(__ORD *)lib;
		else cdir=ORDread(lib,dirbuff,NULL,cdir->parent_adr, False);
		if( (++pthname)[1]/*=='.' */)goto p_dir;
		else continue;
	}
   }
   else if(*pthname=='.')
	switch( pthname[1] ){
	case '/': pthname++; /* self-own */
	case 0 : pthname++;
	}
/* --- make extend function ---- get special path end ----------------- */
   if(*pthname){
	if((dunit=ORDseek(cdir,pthname,_msg/* DIR_READ */))!=NULL)
		cdir=ORDread(lib,dirbuff,dunit,dunit->pDir, False);
	else {	cdir=NULL;	   break;	}
   }
 }
 free((void *)path_nam);
 free(dns);
 if(cdir!=dirbuff){
	free(dirbuff);
	if(cdir)cdir->otherOpen++;
	}
 if(cdir){
	if(cdir->otherOpen==0)addOpenList(cdir);
	if(pGetPdExt/*&&pthname!=path_nam*/)pGetPdExt(cdir);
	}
 return cdir;
}
idxdscpt=NoBuff_2;
return NULL;
}

__ORD *ORDcreat(__ORD *odir, char *pth, const un_Int *pms)
{
if(odir){
__ORD *cdir=NULL, *dir=NULL;
char *dirnam;
__ORL *lib=odir->lib;
if(pth==NULL||*pth==0)idxdscpt=PthInv_7;
else if( (cdir=ORDparent(odir, pth, &dirnam) ) )nameCRC(dirnam);

if(idxdscpt>0x7ffd){
    if((cdir->mode&ORL_OEM)&&(cdir->mdf&NEW_DIR/* Create */)==0)idxdscpt=OEM_Dir_10;
    else {
    DirFCU *dirUnit=ORDseek(cdir,dirnam,DIR_WRITE);
    if(idxdscpt>0x7ffd){
	dir=ORDalloc();
	memcpy(dir->name,dirnam,DirNamLen-1);
	dir->lib=lib;
	setPdPara(dir,pms);
	dir->tag=1;
	dir->savelen= DIR_SAV_SIZ;

	cdir->selfdirs+=1; cdir->selfsize+=dir->savelen;
	lib->tolDir+=1; cdir->mdf|=1;
	if(isNormDir(cdir))dir->parent_adr=cdir->own_adr;
	if(lib->FCU_dyw==0)creatFCT(cdir,cdir->Dir_FCUs_Block*Dir_FCU_Len+sizeof(dskadr_t), 0);
	dir->own_adr=dirUnit->pDir ? dirUnit->pDir:lib->fsz;
	dir->Own_FCU_Addr=lib->FCU_dyw;
	lib->useSize+=dir->savelen;
	lib->fsz+=dir->savelen;
	addOpenList(dir);
	ORtime(0, dir->datebuf);
	free(dirUnit);
	if(cdir==odir&&cdir->mdf&FIRST_FCT)ORDsave(cdir);
	setZero(dir, 0);
     } /* creat sucesse */
  }
}
else if(idxdscpt==NoDir_6)idxdscpt=PthInv_7;
// if( cdir!=odir )
ORDclose(cdir,1);
return dir;
}
idxdscpt=NoBuff_2;
return NULL;
}
