/*
  Write & edit by Linjianghua 2004-2006
  Free under LGPL
*/
#include "ordir.h"
#include "orlio.h"
#include "rebuild.h"

#include "pathopen.c"

StrList orlPaths;

const BYTE FileFmt[blockSize]="ORL\0\3\2\012";

__ORL *ORLalloc()
{
__ORL *rtl=(__ORL *)zalloc(sizeof(__ORL));
rtl->CurDir=(__ORD *)rtl;
rtl->lib=rtl;
return rtl;
}

const char extORL[]=".orl";
__ORL *ORLopen(const char *filenam, int msg)
{
if(filenam){
 const char *oldfnm=filenam, *rc;
 BYTE _ctrl[blockSize];
 __ORL *lib;
 BOOL dect=msg&DectName;
 FILE *pff;
 idxdscpt=0x7fff;
 ropen: pff=dect ? fopen64(filenam,"rb+") : pathopen(filenam,R_OK|W_OK, &rc, &orlPaths);
 if(pff){
     if(fread(_ctrl,1,blockSize, pff)<blockSize ||
	strcmp((const char *)_ctrl, FileFmt ) && 
	!(strcmp((const char *)_ctrl, "FSP")==0 && (_ctrl[5]>2 || (_ctrl[5]>1 && _ctrl[6]>4)) )/* FSP 3.2.6 can compact */
	){
	idxdscpt=1;	fclose(pff);
	if(!dect)free((void *)rc);
	else return NULL;
	goto Re_Open;
     }
   }
   else {
     if(idxdscpt>0x7ffd)idxdscpt=0;
     if(dect)return NULL;
     Re_Open: if(oldfnm==filenam&&memstr(oldfnm,0, extORL, sizeof(extORL), 0)==NULL){
	    filenam=catstr(oldfnm,extORL,0);
	    goto ropen;
	  }
	skpexit: if(filenam!=oldfnm)free((void *)filenam);
	return NULL;
   }
   lib=ORLalloc();/* mem alloc */
   lib->fpt=pff;
   if(fread(&lib->mode, _ctrl[fmt_CtrlSize],1,pff)<1){ idxdscpt=3; goto skpexit; }
/*   lib->ver1=_ctrl[prognamLen+1];
   lib->ver2=_ctrl[prognamLen+2];
   lib->ver3=_ctrl[prognamLen+3];
   lib->CtrlSiz=_ctrl[fmt_CtrlSize];*/
   memcpy(&lib->ver1,_ctrl+prognamLen+1, 4);
   lib->Num_FCU_Len=getLenght((__ORD *)lib);
   struct stat64 st;
   fstat64(pff->_fileno, &st);
   lib->fsz=st.st_size;
//    lib->zcachsiz=pms[pd_param_cnt];
   setZero((__ORD *)lib, 0);
   if(oldfnm!=filenam)free((void *)filenam);
   if(!dect)lib->fname=rc;
   idxdscpt=0x7fff;/* clear it for scriptfile */
   if((msg&FastBuf)==0)setbuf(pff, NULL);
   return lib;
 }
 else return NULL;
}

void ORLclose(__ORL *lib,__ORL* (*Compr)(__ORL *,const char *,int))
{
if(lib){
    while(lib->cnt_usedir>0)
	ORDclose(lib->usedirs[0], 0);
    if(lib->mdf){
      lib->DefaultDir=/*isRoot(lib->CurDir) ? 0 : */lib->CurDir->own_adr;
      if(Compr){
	unsigned int sz=lib->fsz-lib->useSize;
	lib->openMode=0;
	if(sz > lib->CmprSiz*1024 &&
		( sz>0xffffff ? sz/(lib->fsz/100) : (sz*100/lib->fsz) ) > lib->cmprPer)
		lib=Compr(lib,NULL, ShowTips /* show "ORLrebuild..." */ );
	}
      if(lib->mdf&127)ORtime(0, lib->datebuf); /* 128(OnlyChDir) no chtime */
      dkwrite(lib,blockSize, &lib->mode, lib->CtrlSiz);
    }
    if(lib->fname)free((void *)lib->fname);
    fclose(lib->fpt);
    free(lib);
  }
}
