/*
	Write & edit by Linjianghua(Xempo) 2004-2006,2008-2011
	Free under LGPL
*/

#include <utime.h>
#include <sys/stat.h>
#include "ortime.h"
#include "ordir.h"
#include "numbtype.h"
#include "../objcom/comm.h"

FILE *rtlout, *logfp;

const char MemoChs[]="Memo", *outfn;
static const char arEng[3][6]={ "bzip2", "gzip", "lzma" };

union Cvt {
long long lVar;
int iVar;
short sVar;
char ch;
};

union uCvt {
unsigned long long lVar;
unsigned int iVar;
unsigned short sVar;
BYTE ch;
};

char *sysIdRead(__ORL *lib, int numb)
{
MAU send;
BYTE *fcu;
lib->sys_Id_done=True;
if((fcu=NumRead((__ORD *)lib, numb, &send, 1)) )free(fcu);
lib->sys_Id_done=False;
return send.buf;
}

void outCvt(MAU *send,int t)
{/* text void is same effect in read, is defferecnt of input(free write) */
char *pt=send->buf, *buf;
if( IsIntType(t) &&pt){
	union Cvt  cvt;
	union uCvt *pUcvt=(union uCvt *)&cvt;
	int j, len=0,
	s=intType[t],
	intcnt=send->len/s;

	buf=(char *)malloc(send->len * 5 + 8/* safe */);/* 8bit alloc 4char */
	for(j=0;j<intcnt;j++,pt+=s){
		memcpy(&cvt, pt, s);
		len+=sprintf(buf+len,CvtFmt[t], t<int_type_count ? (s>1? (s==2 ? cvt.sVar : (s>4 ? cvt.lVar : cvt.iVar)) : cvt.ch) :
			(s>1? (s==2 ? pUcvt->sVar : (s>4 ? pUcvt->lVar : pUcvt->iVar))  : pUcvt->ch)
		 );
		}
	free(send->buf);
	send->len=--len;  /* -1 is del end(,) */
	send->buf=buf;
	}
}

inline void showMAU(FILE *fp,MAU *pdat, int type, BOOL msg)
{
if(pdat->buf){
  static char hdtag[]=" .";
  outCvt(pdat,type);
  if(msg){
	if(fp==stdout){
		if(getMsg)PrnTxt(0, 34, hdtag);
		else printf("\033[34m%s\033[0m ", hdtag);
	}
	else fwrite(hdtag,2,1,fp);
  }

  pdat->buf[pdat->len]=0;
  if(getMsg && fp==stdout ){
//	if(pdat->len>60000)pdat->len=59999;
	getMsg(pdat->buf);
	}
  else fprintf(fp, "%s\n", pdat->buf);

  free(pdat->buf);
}
}

void read_ar(__ORD *dir, BYTE *fcu, const char *outfn, int idx, int msg)
{
	const char *fn, *fn2, *pt;
	int i, numb, SStech, isAr=(fcu[1]&(~15));
	char txt[24], txt2[24], *buf;
	FILE *readfp, *fp;
	static const char releaTmp[]="releaTmp";
	unsigned int alen, len, cn;
	dskadr_t *padr;
	SStech=(*fcu>>2);
	if(SStech>0)alen=SStech;
	else padr=getDAU(dir, fcu, &alen, &len, 0);
	numb=FCU_Numb(dir, fcu);
	if(idx==0){
	    for(i=1; i<4 ; i++)
		if(isAr==(1<<(4+i))){
	    		idx=i;	break;
			}
	}
	if(outfn&&0==(msg&128))fn=outfn;
	else if(isAr && dir->DAUC>1 &&  len>0){
		MAU m;
		readDAU(dir, fcu, &m, 1);
		fn=m.buf;
		}
		else {
			(void)sprintf(txt, "%d.txt", numb);
			fn=txt;
		}
	if( idx ){
		static const char *extNam[3]={ "bz2", "gz", "lzma" };
		fn2=fn;
		fn=releaTmp; i=0;
		while(access(fn, F_OK)==0 && i<20000){
			(void)sprintf(txt2, "%s%d", releaTmp, ++i);
			fn=txt2;
			}
		fn=catstr(fn, extNam[idx-1], '.');
	}
	struct stat64 existDir;
	if(stat64(fn, &existDir)==0 && S_ISDIR(existDir.st_mode)){
		(void)sprintf(txt2, isAr&&dir->DAUC>1 ? "%d.tx0" : "%d.txt", numb );
		pt=catstr(fn, txt2, '/');
		if(fn!=txt&&fn!=outfn)free((void *)fn);
		fn=pt;
	}
	i=0;
_rerdau_:	if(!(fp=fopen64(fn, "wb"))){
		idxdscpt=11;
		goto _ex_;
		}
	struct archstat archst;
	if(SStech>0){
		fwrite(fcu+(dir->lib->sys_Id_done||isZero(dir->Format) ? FCU_NumPos : FCU_NumPos+sizeof(int) ), len,1, fp);
		fclose(fp);
	}
	else {
	  readfp=dir->lib->fpt;
	  fseek(readfp, *padr, 0);
	  if(isAr)fread(&archst, sizeof(struct archstat), 1, readfp);
#define blk_size  16384
	  buf=(char *)malloc(len >blk_size ? blk_size : len);
	  while(len>0){
		cn= len >blk_size ? blk_size : len;
		fread(buf, cn, 1, readfp);
		fwrite(buf, cn, 1, fp);
		len-=cn;
		}
	  if(isAr && idx < 1){
		fchmod(fp->_fileno, archst.mode);
		fchown(fp->_fileno, archst.uid, archst.gid);
		}
	  fclose(fp);
	  free(buf);
	}
	struct  utimbuf  utm;
	cvttim(&utm.modtime, fcu+FCU_TimePos);
	utm.actime=utm.modtime;
	if(isAr && idx > 0){
		static const char *cmdstr[3]={ "bzip2 -cd", "gzip -cd", "lzma -cd" },
			*cmdstr2[3]={"bzip2 -fcd", "gzip -fcd", "lzma -fcd" };
		const char *cmd=catstr(msg&1 ? cmdstr2[idx-1] : cmdstr[idx-1], fn, 32);
		pt=catstr(cmd, ">", 32);
		free((void *)cmd);
		if(msg&128){
			const char *swap=fn2;
			fn2=catstr(outfn, fn2, '/');
			if(swap!=txt&&swap!=outfn)free((void *)swap);
			}
		cmd=catstr(pt, fn2, 32);
		free((void *)pt);
		system(cmd);
		free((void *)cmd);
		chmod(fn2, archst.mode);
		chown(fn2, archst.uid, archst.gid);
		utime(fn2, &utm);
		remove(fn);
		if(fn2!=txt&&fn2!=outfn)free((void *)fn2);
	}
	else utime(fn, &utm);
	if(!isAr && ++i<dir->DAUC){
		char *tmp=strrchr(fn, '/');
		*tmp=0;
		(void)sprintf(txt2, "%d.tx%d", numb, i );
		tmp=catstr(fn, txt2, '/');
		if(fn!=txt&&fn!=outfn)free((void *)fn);
		fn=tmp;
		padr=getDAU(dir, fcu, &alen, &len, i);
		goto _rerdau_;
		}
_ex_:	if(fn!=txt&&fn!=outfn)free((void *)fn);
}

void _readAr(__ORD *dir, int numb, const char *outfn, int type, int msg)
{
	BYTE *fcu;
	if( (fcu=seekFCU(dir,numb,NULL, (NUMB_READ)|(ARCH_NORM) )) ){
		read_ar(dir, fcu, outfn, type, msg);
		free(fcu);
		}
	else reportBug();
}

void readAr(__ORL *lib, char *pth, const char *outfn, const arglist *lst, int msg/* force */)
{
int numb;
char *pt=divPath(pth,&numb);
if(numNone){
	reportBug();	return;
	}
__ORD *dir=DirOpen(lib->CurDir,pt);
if(idxdscpt>0x7ffd){
	int   idx=0;
	if(lst && lst->argc>0)
		for(idx=1; idx<4 && strcmp(lst->argv[0], arEng[idx-1]); idx++);
	if(idx>3){
		msgShow(lst->argv[0]);
		ORtips(53, 1);
		idx=0;
	}
	_readAr(dir, numb, outfn, idx, msg);
	}
}

void releasAr(__ORL *lib, int cn, char **pms)
{
 int Val1=0,	Val2=0;
 static const char *chs1="-F",  *_chs1="--force" ,
	*chs2= "-T" , *_chs2= "--type" ;
 ProcOpt opt1={ 1, &chs1, &_chs1, &Val1, 0, NULL, 0 },
	opt2={ 1, &chs2, &_chs2, &Val2, 0, NULL, 0 };
      arglists *alst=procParas(cn, pms, &opt1, &opt2);
  if(alst==NULL||alst->argc<1){
	ORtips(I_None_58, True);
	showUsage(ORL_releafile);
	}
   else readAr(lib, (char *)alst->argv[0], alst->argc>1 ? alst->argv[1] : NULL, alst->subarg, Val1 ? 1 : 0);
  if(alst)argsFree(alst);
}

BOOL NumSelect(__ORL *lib, char **pms, const char *extparm,int nCom)
{
 static FILE *showfp; /*  >> display.txt  */
 static const char putchr[]="\nDisplay %s/%ld\n", pw[]="w";
 int numb;
 BYTE  *fcu=NULL;
 __ORD *dir;
 char  *pt=divPath(pms[0],&numb);
 if(numNone){
	ORtips(WrongOpera_22, 1);
	showUsage(nCom);
	return False;
	}
 dir=DirOpen(lib->CurDir,pt);
 if(idxdscpt>0x7ffd){
   MAU *mau;
   FILE *fp;
   int style=dir->Format, n, j, i, len;
   switch(nCom){
   case ORL_log : if(logfp==NULL){
			if( !(fp=fopen("OpenRose.log",pw)) )goto _skp_;
			logfp=fp;
			}
		break;
   case ORL_readaward : if( !(fp=fopen(outfn, pw)) )goto _skp_;
			break;
   case ORL_output : if(showfp==NULL){
			if(!(fp=fopen("display.txt", pw)) )goto _skp_;
			showfp=fp;
			j=1;
		}
		else { j=0; fp=showfp; }
		pt= isNormDir(dir) ? ORDpath(dir,NULL,0) : (char *)SPC;
		fprintf(fp, putchr+j, pt, numb);
		if(pt!=SPC)free(pt);
		break;
   default : fp=stdout;/* stdout define as &_stream[1] */
   }
	
	n=dir->DAUC;      	mau=MAUalloc(n);
	if( (fcu=NumRead(dir,numb,mau,n )) ){
	  BYTE *types=NULL;
	  rtlout=fp;
	  if(extparm&&*extparm){
		types=(BYTE *)malloc(n);
		extendPara(extparm,types, NULL, n, _void/* '-' */);
		}
	  else if(isType(style))types=fcu+FCU_TypePos( style ); // CvtTypeTxt(stat+(isMode(style)? 2:1),types,n);
	     /*else memset(types,_void,n);*/
	  for(j=0;j<n;j++)showMAU(fp,mau+j, types ? types[j] : (int)_void, n>1);
	  if(isType(style)){
	      const char *chs;
	      if(nCom==ORL_read||nCom==ORL_select)PrnTxt(1,  3, "Type:");
	      for(j=0,len=7;j<n;j++){
		chs=TypeStr[types[j]];
		if(nCom==ORL_read||nCom==ORL_select){
			i=strlen(chs);
			PrnTxt(len, mau[j].len? 7:14, chs);
			len+=i+1;
			}
		else fprintf(fp," %s", chs);
		}
	    fprintf(fp,"\n");
	  }
/*	fprintf(fp,"\t%s\n",ORasctim(FCU_GetDate(stat)) );
	if(nCom==ORL_output)fprintf(fp,"\n");
*/
	  if(types)free(types);
	  free(fcu);
     	}
	else reportBug();
	free(mau);
	if(nCom==ORL_readaward)fclose(fp);
     rtlout=stdout;
_skp_:  ORDclose(dir, 2);
 }
 else reportBug();
return fcu!=NULL;
}

